Index: G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/avr.c
===================================================================
--- G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/avr.c	(revision 1)
+++ G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/avr.c	(working copy)
@@ -141,24 +141,69 @@
   return 0;
 }
 
+static int avr_is_page_empty(unsigned int address, int page_size,
+                                const unsigned char *buf)
+{
+    int i;
+    for(i = 0; i < page_size; i++) {
+        if(buf[address + i] != 0xFF) {
+            /* Page is not empty. */
+            return(0);
+        }
+    }
 
+    /* Page is empty. */
+    return(1);
+}
+
+unsigned int avr_skip_empty_pages(unsigned int FromAddress, int page_size, unsigned int MemSize,
+                                const unsigned char *buf)
+{
+    while (FromAddress < MemSize) {
+    	if (avr_is_page_empty(FromAddress,page_size, buf) == 0) {break;}
+    	FromAddress = FromAddress + page_size;
+    }
+    return(FromAddress);
+}
+
+unsigned int avr_scan_nonempty_pages(unsigned int FromAddress, int page_size, unsigned int MemSize,
+                                const unsigned char *buf)
+{
+    while (FromAddress < MemSize) {
+    	if (avr_is_page_empty(FromAddress,page_size, buf) != 0) {break;}
+    	FromAddress = FromAddress + page_size;
+    }
+    return(FromAddress);
+}
+
 /*
  * Read the entirety of the specified memory type into the
  * corresponding buffer of the avrpart pointed to by 'p'.  If size =
  * 0, read the entire contents, otherwise, read 'size' bytes.
+ * if p <> NULL then use this as pattern to read only nonempty pages from deice
  *
  * Return the number of bytes read, or < 0 if an error occurs.  
  */
 int avr_read(PROGRAMMER * pgm, AVRPART * p, char * memtype, int size, 
-             int verbose)
+             int verbose,
+             AVRPART * v
+             )
 {
   unsigned char    rbyte;
   unsigned long    i;
   unsigned char  * buf;
+  unsigned int	ReadAdress;
+  unsigned int	NextAdress;
   AVRMEM * mem;
+  AVRMEM * vmem;
   int rc;
 
   mem = avr_locate_mem(p, memtype);
+  if (v != NULL) {
+  	vmem = avr_locate_mem(v, memtype);
+  }
+  else {vmem = NULL;}
+  
   if (mem == NULL) {
     fprintf(stderr, "No \"%s\" memory for part %s\n",
             memtype, p->desc);
@@ -175,54 +220,77 @@
    */
   memset(buf, 0xff, size);
 
-  if ((strcmp(mem->desc, "flash")==0) || (strcmp(mem->desc, "eeprom")==0)) {
-    if (pgm->paged_load != NULL) {
-      /*
-       * the programmer supports a paged mode read, perhaps more
-       * efficiently than we can read it directly, so use its routine
-       * instead
-       */
-      if (mem->paged) {
-        rc = pgm->paged_load(pgm, p, mem, mem->page_size, size);
-        if (rc < 0)
-          return rc;
-      }
-      else {
-        rc = pgm->paged_load(pgm, p, mem, pgm->page_size, size);
-        if (rc < 0)
-          return rc;
-      }
-      if (strcasecmp(mem->desc, "flash") == 0)
-        return avr_mem_hiaddr(mem);
-      else
-        return rc;
-    }
-  }
+  ReadAdress = 0;
+  fprintf(stderr, "\nload memory segment %X-%X \n", ReadAdress, ReadAdress + size);
+  rc = 0;
+  while (ReadAdress < size) {
+  
+  	if ( (vmem != NULL) &&
+	     ( (strcmp(mem->desc, "flash")==0) || (strcmp(mem->desc, "eeprom")==0) )
+	   )
+  	{
+  		/*skip empty pages*/
+	  	ReadAdress = avr_skip_empty_pages(ReadAdress, mem->page_size, size, vmem->buf);
+	  	if (ReadAdress >= size) break;
+	  	NextAdress = avr_scan_nonempty_pages(ReadAdress, mem->page_size, size, vmem->buf);
+		fprintf(stderr, "detected segment: %X-%X\n", ReadAdress, NextAdress);
+  	}
+  	else {
+  		ReadAdress = 0;
+  		NextAdress = size;
+  	}
 
-  if (strcmp(mem->desc, "signature") == 0) {
-    if (pgm->read_sig_bytes) {
-      return pgm->read_sig_bytes(pgm, p, mem);
-    }
+	  if 	(( (strcmp(mem->desc, "flash")==0) || (strcmp(mem->desc, "eeprom")==0)
+	  		 ) && (pgm->paged_load != NULL)
+	  		)
+	  {
+	      /*
+	       * the programmer supports a paged mode read, perhaps more
+	       * efficiently than we can read it directly, so use its routine
+	       * instead
+	       */
+	      if (mem->paged) {
+	        rc = pgm->paged_load(pgm, p, mem, mem->page_size, NextAdress - ReadAdress, ReadAdress);
+	        if (rc < 0)
+	          return rc;
+	      }
+	      else {
+	        rc = pgm->paged_load(pgm, p, mem, pgm->page_size, NextAdress - ReadAdress, ReadAdress);
+	        if (rc < 0)
+	          return rc;
+	      }
+		  report_progress(rc, size, NULL);
+	  }
+	  else {
+	
+		  if (strcmp(mem->desc, "signature") == 0) {
+		    if (pgm->read_sig_bytes) {
+		      return pgm->read_sig_bytes(pgm, p, mem);
+		    }
+		  }
+		
+		  for (i=0; i<size; i++) {
+		    rc = avr_read_byte(pgm, p, mem, i, &rbyte);
+		    if (rc != 0) {
+		      fprintf(stderr, "avr_read(): error reading address 0x%04lx\n", i);
+		      if (rc == -1) 
+		        fprintf(stderr, 
+		                "    read operation not supported for memory \"%s\"\n",
+		                memtype);
+		      return -2;
+		    }
+		    buf[i] = rbyte;
+		    report_progress(i, size, NULL);
+		  }/*for*/
+		  rc = i;
+	  }/*if ((strcmp(mem->desc, "flash")*/
+	  fprintf(stderr, "\nsegment %X-%X loaded with result %X\n", ReadAdress, NextAdress, rc);
+	  ReadAdress = NextAdress;
   }
-
-  for (i=0; i<size; i++) {
-    rc = avr_read_byte(pgm, p, mem, i, &rbyte);
-    if (rc != 0) {
-      fprintf(stderr, "avr_read(): error reading address 0x%04lx\n", i);
-      if (rc == -1) 
-        fprintf(stderr, 
-                "    read operation not supported for memory \"%s\"\n",
-                memtype);
-      return -2;
-    }
-    buf[i] = rbyte;
-    report_progress(i, size, NULL);
-  }
-
   if (strcasecmp(mem->desc, "flash") == 0)
     return avr_mem_hiaddr(mem);
   else
-    return i;
+    return rc;
 }
 
 
@@ -516,6 +584,19 @@
   return avr_write_byte_default(pgm, p, mem, addr, data);
 }
 
+unsigned int LastByteAddr(AVRMEM  * m,unsigned int StartAdress, unsigned int LastAdress)
+{
+	unsigned int idx;
+	
+	if (LastAdress > m->size) 
+		{LastAdress = m->size;}
+	for(idx = LastAdress; idx >= StartAdress; --idx){
+		if (m->buf[idx] != 0xff) break;
+	}
+	if (m->buf[idx] != 0xff) 
+		{return idx;}
+	else {return m->size;}
+}
 
 /*
  * Write the whole memory region of the specified memory from the
@@ -527,13 +608,17 @@
  * Return the number of bytes written, or -1 if an error occurs.
  */
 int avr_write(PROGRAMMER * pgm, AVRPART * p, char * memtype, int size, 
-              int verbose)
+              int verbose,
+              int fast)
 {
   int              rc;
   int              wsize;
   unsigned long    i;
   unsigned char    data;
   int              werror;
+  unsigned int WriteAdres;
+  unsigned int NextAdres;
+  unsigned int LastAdres;
   AVRMEM         * m;
 
   m = avr_locate_mem(p, memtype);
@@ -559,65 +644,103 @@
             progname, size, wsize,
             progbuf, wsize);
   }
-
-  if ((strcmp(m->desc, "flash")==0) || (strcmp(m->desc, "eeprom")==0)) {
-    if (pgm->paged_write != NULL) {
-      /*
-       * the programmer supports a paged mode write, perhaps more
-       * efficiently than we can read it directly, so use its routine
-       * instead
-       */
-      return pgm->paged_write(pgm, p, m, m->page_size, size);
-    }
-  }
-
+	
   if (pgm->write_setup) {
       pgm->write_setup(pgm, p, m);
   }
 
-  for (i=0; i<wsize; i++) {
-    data = m->buf[i];
-    report_progress(i, wsize, NULL);
-
-    rc = avr_write_byte(pgm, p, m, i, data);
-    if (rc) {
-      fprintf(stderr, " ***failed;  ");
-      fprintf(stderr, "\n");
-      pgm->err_led(pgm, ON);
-      werror = 1;
-    }
-
-    if (m->paged) {
-      /*
-       * check to see if it is time to flush the page with a page
-       * write
-       */
-      if (((i % m->page_size) == m->page_size-1) ||
-          (i == wsize-1)) {
-        rc = avr_write_page(pgm, p, m, i);
-        if (rc) {
-          fprintf(stderr,
-                  " *** page %ld (addresses 0x%04lx - 0x%04lx) failed "
-                  "to write\n",
-                  i % m->page_size, 
-                  i - m->page_size + 1, i);
-          fprintf(stderr, "\n");
-          pgm->err_led(pgm, ON);
-          werror = 1;
-        }
-      }
-    }
-
-    if (werror) {
-      /* 
-       * make sure the error led stay on if there was a previous write
-       * error, otherwise it gets cleared in avr_write_byte()
-       */
-      pgm->err_led(pgm, ON);
-    }
+  WriteAdres = 0;
+  NextAdres = 0;
+  rc = 0;
+  while (WriteAdres < size) {
+  
+  	if ((fast != 0) && (p->erased != 0) &&
+	    ( (strcmp(m->desc, "flash")==0) || (strcmp(m->desc, "eeprom")==0)
+	    )
+	   )
+  	{
+  		/*skip empty pages*/
+	  	WriteAdres = avr_skip_empty_pages(NextAdres, m->page_size, size, m->buf);
+	  	if (WriteAdres >= size) break;
+	  	NextAdres = avr_scan_nonempty_pages(WriteAdres, m->page_size, size, m->buf);
+		fprintf(stderr, "detected segment: %X-%X\n", WriteAdres, NextAdres);
+  	}
+  	else {
+  		WriteAdres = 0;
+  		NextAdres = size;
+  	}
+  	
+  	LastAdres =  LastByteAddr(m,WriteAdres,NextAdres);
+  	
+	if  ( ( (strcmp(m->desc, "flash")==0) || (strcmp(m->desc, "eeprom")==0)
+		  ) && (pgm->paged_write != NULL)
+		) 
+	{
+	      /*
+	       * the programmer supports a paged mode write, perhaps more
+	       * efficiently than we can read it directly, so use its routine
+	       * instead
+	       */
+	      rc = pgm->paged_write(pgm, p, m, m->page_size, NextAdres - WriteAdres, WriteAdres);
+	      if (rc < 0) {werror = 1;}
+		  report_progress(rc, wsize, NULL);
+	}
+	else {
+	
+		  for (i=WriteAdres; i<NextAdres; i++) {
+		  	
+		    data = m->buf[i];
+		    report_progress(i, wsize, NULL);
+		
+		    rc = avr_write_byte(pgm, p, m, i, data);
+		    if (rc) {
+		      fprintf(stderr, " ***failed;  ");
+		      fprintf(stderr, "\n");
+		      pgm->err_led(pgm, ON);
+		      werror = 1;
+		    }
+		
+		    if (m->paged) {
+		      /*
+		       * check to see if it is time to flush the page with a page
+		       * write
+		       */
+		      if (((i % m->page_size) == m->page_size-1) ||
+		          (i == wsize-1)) {
+		        rc = avr_write_page(pgm, p, m, i);
+		        if (rc) {
+		          fprintf(stderr,
+		                  " *** page %ld (addresses 0x%04lx - 0x%04lx) failed "
+		                  "to write\n",
+		                  i % m->page_size, 
+		                  i - m->page_size + 1, i);
+		          fprintf(stderr, "\n");
+		          pgm->err_led(pgm, ON);
+		          werror = 1;
+		        }
+		      }
+		    }
+			
+			rc = i;
+		    
+		    if (werror) {
+		      /* 
+		       * make sure the error led stay on if there was a previous write
+		       * error, otherwise it gets cleared in avr_write_byte()
+		       */
+		      pgm->err_led(pgm, ON);
+		      break;
+		    }
+		  }
+	}
+    fprintf(stderr, "\nsegment %X-%X written with result %X\n", WriteAdres, NextAdres, rc);
+	if (werror) break;
+	WriteAdres = NextAdres;
   }
-
-  return i;
+  
+  avr_read_byte(pgm, p, m, LastAdres, &data); /*enshure\flush write last page write*/
+  
+  return rc;
 }
 
 
@@ -630,7 +753,7 @@
   int rc;
 
   report_progress (0,1,"Reading");
-  rc = avr_read(pgm, p, "signature", 0, 0);
+  rc = avr_read(pgm, p, "signature", 0, 0, 0);
   if (rc < 0) {
     fprintf(stderr,
             "%s: error reading signature data for part \"%s\", rc=%d\n",
@@ -795,6 +918,7 @@
             progname, cycles);
     avr_put_cycle_count(pgm, p, cycles);
   }
+  p->erased = 1;
 
   return rc;
 }
Index: G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/avr.h
===================================================================
--- G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/avr.h	(revision 1)
+++ G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/avr.h	(working copy)
@@ -36,7 +36,8 @@
                   unsigned long addr, unsigned char * value);
 
 int avr_read(PROGRAMMER * pgm, AVRPART * p, char * memtype, int size,
-             int verbose);
+             int verbose,
+             AVRPART * v);
 
 int avr_write_page(PROGRAMMER * pgm, AVRPART * p, AVRMEM * mem,
                    unsigned long addr);
@@ -45,7 +46,8 @@
                    unsigned long addr, unsigned char data);
 
 int avr_write(PROGRAMMER * pgm, AVRPART * p, char * memtype, int size,
-              int verbose);
+              int verbose,
+              int fast);
 
 int avr_signature(PROGRAMMER * pgm, AVRPART * p);
 
Index: G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/avr910.c
===================================================================
--- G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/avr910.c	(revision 1)
+++ G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/avr910.c	(working copy)
@@ -301,33 +301,44 @@
   avr910_vfy_cmd_sent(pgm, "set addr");
 }
 
-
 static int avr910_write_byte(PROGRAMMER * pgm, AVRPART * p, AVRMEM * m,
                              unsigned long addr, unsigned char value)
 {
   char cmd[2];
-
+  int  wordbytes;
+  unsigned long part_addr;
+  unsigned long word_addr;
+  
   if (strcmp(m->desc, "flash") == 0) {
-    if (addr & 0x01) {
-      cmd[0] = 'C';             /* Write Program Mem high byte */
-    }
-    else {
-      cmd[0] = 'c';
-    }
-
-    addr >>= 1;
+  	wordbytes = take_adress(m,addr,2,&part_addr,&word_addr);
+	if (wordbytes <= 0) 
+	  	{return wordbytes;}
+  	if (wordbytes == 2) {
+		    if (addr & 0x01) {
+		      cmd[0] = 'C';             /* Write Program Mem high byte */
+		    }
+		    else {
+		      cmd[0] = 'c';
+		    }
+  	}
+  	else{
+		    cmd[0] = 'c';
+  	}
   }
   else if (strcmp(m->desc, "eeprom") == 0) {
+  	wordbytes = take_adress(m,addr,1,&part_addr,&word_addr);
     cmd[0] = 'D';
   }
   else {
     return -1;
   }
-
+  
+  if (wordbytes <= 0) 
+  	{return wordbytes;}
+  
   cmd[1] = value;
 
-  avr910_set_addr(pgm, addr);
-
+  avr910_set_addr(pgm, part_addr);
   avr910_send(pgm, cmd, sizeof(cmd));
   avr910_vfy_cmd_sent(pgm, "write byte");
 
@@ -339,32 +350,31 @@
                                   unsigned long addr, unsigned char * value)
 {
   static int cached = 0;
-  static unsigned char cvalue;
+  static unsigned char cvalue[4];
   static unsigned long caddr;
+  unsigned long part_addr;
+  unsigned long word_addr;
+  int wordbytes;
+  
 
-  if (cached && ((caddr + 1) == addr)) {
-    *value = cvalue;
-    cached = 0;
+  wordbytes = take_adress(m,addr,2,&part_addr,&word_addr);
+  if (wordbytes <= 0) 
+  	{return wordbytes;}
+  
+  if (cached && ((caddr) == part_addr)) {
+    *value = cvalue[addr - word_addr];
   }
   else {
-    char buf[2];
+    avr910_set_addr(pgm, part_addr);
 
-    avr910_set_addr(pgm, addr >> 1);
-
     avr910_send(pgm, "R", 1);
 
+    avr910_recv(pgm, cvalue, wordbytes);
+    caddr = part_addr;
+    cached = 1;
     /* Read back the program mem word (MSB first) */
-    avr910_recv(pgm, buf, sizeof(buf));
-
-    if ((addr & 0x01) == 0) {
-      *value = buf[1];
-      // cached = 1;
-      cvalue = buf[0];
-      caddr = addr;
-    }
-    else {
-      *value = buf[0];
-    }
+    swap_endian(cvalue, wordbytes);
+    *value = cvalue[addr - word_addr];
   }
 
   return 0;
@@ -398,18 +408,28 @@
 
 
 static int avr910_paged_write_flash(PROGRAMMER * pgm, AVRPART * p, AVRMEM * m, 
-                                    int page_size, int n_bytes)
+                                    int page_size, int n_bytes, unsigned long addr)
 {
   unsigned char cmd[] = {'c', 'C'};
   char buf[2];
-  unsigned int addr = 0;
-  unsigned int max_addr = n_bytes;
+  unsigned int max_addr;
+  unsigned int low_addr;
   unsigned int page_addr;
+  unsigned long part_addr;
+  unsigned long word_addr;
   int page_bytes = page_size;
   int page_wr_cmd_pending = 0;
+  int wordbytes;
 
   page_addr = addr;
-  avr910_set_addr(pgm, addr>>1);
+  low_addr = addr;
+  max_addr = addr + n_bytes;
+  
+  wordbytes = take_adress(m,addr,2,&part_addr,&word_addr);
+  if (wordbytes <= 0) 
+  	{return wordbytes;}
+  
+  avr910_set_addr(pgm, part_addr);
 
   while (addr < max_addr) {
     page_wr_cmd_pending = 1;
@@ -424,31 +444,44 @@
     if (m->paged && (page_bytes == 0)) {
       /* Send the "Issue Page Write" if we have sent a whole page. */
 
-      avr910_set_addr(pgm, page_addr>>1);
+	  if (wordbytes == 2) {	part_addr = page_addr >> 1;}
+	  else {part_addr = page_addr;}
+	  
+      avr910_set_addr(pgm, part_addr);
       avr910_send(pgm, "m", 1);
       avr910_vfy_cmd_sent(pgm, "flush page");
 
       page_wr_cmd_pending = 0;
       usleep(m->max_write_delay);
-      avr910_set_addr(pgm, addr>>1);
-
+	  
       /* Set page address for next page. */
 
       page_addr = addr;
       page_bytes = page_size;
+
+	  if (wordbytes == 2) {	part_addr = page_addr >> 1; }
+	  else {part_addr = page_addr; }
+      avr910_set_addr(pgm, part_addr);
+
     }
     else if ((has_auto_incr_addr != 'Y') && ((addr & 0x01) == 0)) {
-      avr910_set_addr(pgm, addr>>1);
+	  if (wordbytes == 2) 
+	  	{	part_addr = page_addr >> 1;}
+	  else {part_addr = page_addr; }
+      avr910_set_addr(pgm, part_addr);
     }
 
-    report_progress (addr, max_addr, NULL);
-  }
+    report_progress (addr - low_addr, n_bytes, NULL);
+  }/*while*/
 
   /* If we didn't send the page wr cmd after the last byte written in the
      loop, send it now. */
 
   if (page_wr_cmd_pending) {
-    avr910_set_addr(pgm, page_addr>>1);
+	if (wordbytes == 2) {
+	  	page_addr >>= 1;
+	}
+    avr910_set_addr(pgm, page_addr);
     avr910_send(pgm, "m", 1);
     avr910_vfy_cmd_sent(pgm, "flush final page");
     usleep(m->max_write_delay);
@@ -459,13 +492,15 @@
 
 
 static int avr910_paged_write_eeprom(PROGRAMMER * pgm, AVRPART * p,
-                                     AVRMEM * m, int page_size, int n_bytes)
+                                     AVRMEM * m, int page_size, int n_bytes, unsigned long addr)
 {
   char cmd[2];
-  unsigned int addr = 0;
-  unsigned int max_addr = n_bytes;
+  unsigned int max_addr;
+  unsigned int low_addr;
 
   avr910_set_addr(pgm, addr);
+  max_addr = addr + n_bytes;
+  low_addr = addr;
 
   cmd[0] = 'D';
 
@@ -481,7 +516,7 @@
       avr910_set_addr(pgm, addr);
     }
 
-    report_progress (addr, max_addr, NULL);
+    report_progress (addr - low_addr, n_bytes, NULL);
   }
 
   return addr;
@@ -489,13 +524,13 @@
 
 
 static int avr910_paged_write(PROGRAMMER * pgm, AVRPART * p, AVRMEM * m,
-                              int page_size, int n_bytes)
+                              int page_size, int n_bytes, unsigned long adress)
 {
   if (strcmp(m->desc, "flash") == 0) {
-    return avr910_paged_write_flash(pgm, p, m, page_size, n_bytes);
+    return avr910_paged_write_flash(pgm, p, m, page_size, n_bytes, adress);
   }
   else if (strcmp(m->desc, "eeprom") == 0) {
-    return avr910_paged_write_eeprom(pgm, p, m, page_size, n_bytes);
+    return avr910_paged_write_eeprom(pgm, p, m, page_size, n_bytes, adress);
   }
   else {
     return -2;
@@ -504,53 +539,58 @@
 
 
 static int avr910_paged_load(PROGRAMMER * pgm, AVRPART * p, AVRMEM * m, 
-                             int page_size, int n_bytes)
+                             int page_size, int n_bytes, unsigned long addr)
 {
   char cmd;
   int rd_size;
-  unsigned int addr = 0;
   unsigned int max_addr;
+  unsigned int low_addr;
+  unsigned long part_addr;
+  unsigned long word_addr;
   char buf[2];
 
+  rd_size = take_adress(m,addr,2,&part_addr,&word_addr);
+  if (rd_size <= 0) 
+  	{return rd_size;}
+  
   if (strcmp(m->desc, "flash") == 0) {
     cmd = 'R';
-    rd_size = 2;                /* read two bytes per addr */
   }
   else if (strcmp(m->desc, "eeprom") == 0) {
     cmd = 'd';
-    rd_size = 1;
   }
   else {
     return -2;
   }
 
-  max_addr = n_bytes/rd_size;
+  max_addr = addr + n_bytes;
+  low_addr = addr;
+  avr910_set_addr(pgm, part_addr);
 
-  avr910_set_addr(pgm, addr);
-
   while (addr < max_addr) {
+  	
     avr910_send(pgm, &cmd, 1);
     if (cmd == 'R') {
+      avr910_recv(pgm, &(m->buf[word_addr]), rd_size);
       /* The 'R' command returns two bytes, MSB first, we need to put the data
          into the memory buffer LSB first. */
-      avr910_recv(pgm, buf, 2);
-      m->buf[addr*2]   = buf[1];  /* LSB */
-      m->buf[addr*2+1] = buf[0];  /* MSB */
+      swap_endian(&(m->buf[word_addr]), rd_size);
     }
     else {
       avr910_recv(pgm, (char *)&m->buf[addr], 1);
     }
 
-    addr++;
+    addr += rd_size;
+    take_adress(m,addr,2,&part_addr,&word_addr);
 
     if (has_auto_incr_addr != 'Y') {
-      avr910_set_addr(pgm, addr);
+      avr910_set_addr(pgm, part_addr);
     }
 
-    report_progress (addr, max_addr, NULL);
+    report_progress (addr - low_addr, n_bytes , NULL);
   }
 
-  return addr * rd_size;
+  return addr;
 }
 
 /* Signature byte reads are always 3 bytes. */
Index: G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/avrdude.conf.in
===================================================================
--- G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/avrdude.conf.in	(revision 1)
+++ G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/avrdude.conf.in	(working copy)
@@ -74,6 +74,8 @@
 #           paged           = <yes/no> ;          # yes / no
 #           size            = <num> ;             # bytes
 #           page_size       = <num> ;             # bytes
+#			word_size		= <num> ;			  # bytes, size of the word 
+#													default 2 byte 4 flash and 1 byte 4 others
 #           num_pages       = <num> ;             # numeric
 #           min_write_delay = <num> ;             # micro-seconds
 #           max_write_delay = <num> ;             # micro-seconds
@@ -214,8 +216,9 @@
 #
 default_parallel   = "@DEFAULT_PAR_PORT@";
 default_serial     = "@DEFAULT_SER_PORT@";
+default_fastwrite  = 0;
+default_fastverify = 0;
 
-
 #
 # PROGRAMMER DEFINITIONS
 #
Index: G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/avrpart.c
===================================================================
--- G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/avrpart.c	(revision 1)
+++ G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/avrpart.c	(working copy)
@@ -369,6 +369,7 @@
   p->flags = AVRPART_SERIALOK | AVRPART_PARALLELOK | AVRPART_ENABLEPAGEPROGRAMMING;
   p->config_file[0] = 0;
   p->lineno = 0;
+  p->erased = 0;
 
   p->mem = lcreat(NULL, 0);
 
@@ -535,3 +536,59 @@
   if (buf)
     free(buf);
 }
+
+int take_adress(AVRMEM * m, unsigned long addr, int max_width, unsigned long * part_addr, unsigned long  * word_addr)
+/* addr - requested to operation adress*/
+/* part_addr - adress of part memory that contains requested word*/
+/* word_addr - adress of requested word in byte organised memory m*/
+/*returns width of memory word, if error occurs - return -1*/
+{
+  	int wordsize;
+  	
+  	wordsize = m->wordsize;
+  	if (wordsize == 0) {
+  		if (strcmp(m->desc, "flash") == 0) { 		
+  			wordsize = 2;
+  		}
+  		else {wordsize = 1;}
+  	}
+  	
+  	if (wordsize > max_width) {
+  			fprintf(stderr,"try use word as %i bytes width? cant operate with this width", wordsize);
+    		return -1;
+    }
+    
+  	switch (wordsize){
+  		case 2 : {
+		    *part_addr = addr >> 1;
+		    *word_addr = *part_addr << 1;
+		    break;
+  		}
+  		case 1 : {
+		    *part_addr = addr;
+		    *word_addr = addr;
+  			break;
+  		}
+  		default : {
+  			*part_addr = addr / wordsize;
+  			*word_addr = addr % wordsize;
+  		}
+  	}/*switch*/
+  	
+  	return wordsize;
+}
+
+void swap_endian(char * buf, int wordbytes)
+// swaps bytes of word to reverse received order
+{
+	int curidx;
+	char tmp;
+	
+	if (wordbytes == 1) {return 0;}
+	for (curidx = 0; curidx < (wordbytes >> 1) ; curidx++) {
+		tmp = buf[curidx];
+		buf[curidx] = buf[wordbytes -1 - curidx];
+		buf[wordbytes -1 - curidx] = tmp;
+	}
+	
+}
Index: G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/avrpart.h
===================================================================
--- G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/avrpart.h	(revision 1)
+++ G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/avrpart.h	(working copy)
@@ -118,6 +118,7 @@
   LISTID        mem;                /* avr memory definitions */
   char          config_file[PATH_MAX]; /* config file where defined */
   int           lineno;                /* config file line number */
+  int			erased;				/*setup to 1 after part errasing*/
 } AVRPART;
 
 #define AVR_MEMDESCLEN 64
@@ -125,6 +126,8 @@
   char desc[AVR_MEMDESCLEN];  /* memory description ("flash", "eeprom", etc) */
   int paged;                  /* page addressed (e.g. ATmega flash) */
   int size;                   /* total memory size in bytes */
+  int wordsize;               /* sizeof memory word - memory adresses by words*/
+  							  /* by default is set on 2 bytes 4 flash and 1 byte 4 others*/
   int page_size;              /* size of memory page (if page addressed) */
   int num_pages;              /* number of pages (if page addressed) */
   int min_write_delay;        /* microseconds */
@@ -160,6 +163,15 @@
 void avr_mem_display(char * prefix, FILE * f, AVRMEM * m, int type,
                      int verbose);
 
+int take_adress(AVRMEM * m, unsigned long addr, int max_width, unsigned long * part_addr, unsigned long  * word_addr);
+/* addr - requested to operation adress*/
+/* part_addr - adress of part memory that contains requested word*/
+/* word_addr - adress of requested word in byte organised memory m*/
+/*returns width of memory word, if error occurs - return -1*/
+void swap_endian(char * buf, int wordbytes);
+/* swaps bytes of word to reverse received order*/
+
+
 /* Functions for AVRPART structures */
 AVRPART * avr_new_part(void);
 AVRPART * avr_dup_part(AVRPART * d);
Index: G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/butterfly.c
===================================================================
--- G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/butterfly.c	(revision 1)
+++ G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/butterfly.c	(working copy)
@@ -424,8 +424,15 @@
 {
   char cmd[6];
   int size;
+  unsigned long part_addr;
+  unsigned long word_addr;
+  int wordbytes;
 
   no_show_func_info();
+  
+  wordbytes = take_adress(m,addr,2,&part_addr,&word_addr);
+  if (wordbytes <= 0) 
+  	{return wordbytes;}
 
   if ((strcmp(m->desc, "flash") == 0) || (strcmp(m->desc, "eeprom") == 0))
   {
@@ -441,7 +448,7 @@
       size = 6;
       return -1;
     }
-    butterfly_set_addr(pgm, addr);
+    butterfly_set_addr(pgm, part_addr);
   }
   else if (strcmp(m->desc, "lock") == 0)
   {
@@ -463,32 +470,28 @@
                                   unsigned long addr, unsigned char * value)
 {
   static int cached = 0;
-  static unsigned char cvalue;
+  static unsigned char cvalue[4];
   static unsigned long caddr;
+  unsigned long part_addr;
+  unsigned long word_addr;
+  int wordbytes;
 
-  if (cached && ((caddr + 1) == addr)) {
-    *value = cvalue;
-    cached = 0;
+  wordbytes = take_adress(m,addr,4,&part_addr,&word_addr);
+  if (wordbytes <= 0) 
+  	{return wordbytes;}
+
+  if (cached && (caddr == part_addr)) {
+    *value = cvalue[addr - word_addr];
   }
   else {
-    char buf[2];
+    char cmd[4] = "g\000\002F";
 
-    butterfly_set_addr(pgm, addr >> 1);
-
-    butterfly_send(pgm, "g\000\002F", 4);
-
-    /* Read back the program mem word (MSB first) */
-    butterfly_recv(pgm, buf, sizeof(buf));
-
-    if ((addr & 0x01) == 0) {
-      *value = buf[1];
-      cached = 1;
-      cvalue = buf[0];
-      caddr = addr;
-    }
-    else {
-      *value = buf[0];
-    }
+    butterfly_set_addr(pgm, part_addr);
+    cmd[2] = (char) wordbytes;
+    butterfly_send(pgm, cmd, sizeof(cmd));
+    butterfly_recv(pgm, cvalue, sizeof(cvalue));
+    cached = 1;
+    *value = cvalue[addr - word_addr];
   }
 
   return 0;
@@ -544,20 +547,29 @@
 
 
 static int butterfly_paged_write(PROGRAMMER * pgm, AVRPART * p, AVRMEM * m, 
-                              int page_size, int n_bytes)
+                              int page_size, int n_bytes, unsigned long addr)
 {
-  unsigned int addr = 0;
-  unsigned int max_addr = n_bytes;
+  unsigned int max_addr;
+  unsigned int low_addr;
   char *cmd;
   unsigned int blocksize = buffersize;
+  unsigned long part_addr;
+  unsigned long word_addr;
+  int wordbytes;
 
+  wordbytes = take_adress(m,addr,4,&part_addr,&word_addr);
+  if (wordbytes <= 0) 
+  	{return wordbytes;}
+
   if (strcmp(m->desc, "flash") && strcmp(m->desc, "eeprom")) 
     return -2;
 
   if (m->desc[0] == 'e')
     blocksize = 1;		/* Write to eeprom single bytes only */
 
-  butterfly_set_addr(pgm, addr);
+  butterfly_set_addr(pgm, part_addr);
+  max_addr = addr + n_bytes;
+  low_addr = addr;
 
 #if 0
   usleep(1000000);
@@ -577,13 +589,14 @@
     memcpy(&cmd[4], &m->buf[addr], blocksize);
     cmd[1] = (blocksize >> 8) & 0xff;
     cmd[2] = blocksize & 0xff;
-
+	
+//	fprintf(stderr, "sending block at adress:%X\n",addr);
     butterfly_send(pgm, cmd, 4+blocksize);
     butterfly_vfy_cmd_sent(pgm, "write block");
 
     addr += blocksize;
 
-    report_progress (addr, max_addr, NULL);
+    report_progress (addr - low_addr, n_bytes, NULL);
   } /* while */
   free(cmd);
 
@@ -593,24 +606,31 @@
 
 
 static int butterfly_paged_load(PROGRAMMER * pgm, AVRPART * p, AVRMEM * m, 
-                             int page_size, int n_bytes)
+                             int page_size, int n_bytes, unsigned long addr)
 {
-  unsigned int addr = 0;
-  unsigned int max_addr = n_bytes;
-  int rd_size = 1;
+  unsigned int max_addr, low_addr;
+  unsigned long part_addr;
+  unsigned long word_addr;
+  int wordbytes;
 
+  wordbytes = take_adress(m,addr,4,&part_addr,&word_addr);
+  if (wordbytes <= 0) 
+  	{return wordbytes;}
+
   /* check parameter syntax: only "flash" or "eeprom" is allowed */
   if (strcmp(m->desc, "flash") && strcmp(m->desc, "eeprom")) 
     return -2;
 
   {		/* use buffered mode */
+  	max_addr = addr + n_bytes;
+  	low_addr = addr;
     char cmd[4];
     int blocksize = buffersize;
 
     cmd[0] = 'g';
     cmd[3] = toupper(m->desc[0]);
 
-    butterfly_set_addr(pgm, addr);
+    butterfly_set_addr(pgm, part_addr);
     while (addr < max_addr) {
       if ((max_addr - addr) < blocksize) {
         blocksize = max_addr - addr;
@@ -623,11 +643,11 @@
 
       addr += blocksize;
 
-      report_progress (addr, max_addr, NULL);
+      report_progress (addr - low_addr, n_bytes, NULL);
     } /* while */
   }
 
-  return addr * rd_size;
+  return addr;
 }
 
 
Index: G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/ChangeLog
===================================================================
--- G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/ChangeLog	(revision 1)
+++ G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/ChangeLog	(working copy)
@@ -1,3 +1,33 @@
+2006-02-08 AlexRayne <alexrainpe196@newmail.ru>
+	
+	* avr.c:
+	* avrpart.c:
+	* avrpart.h:
+	* avr910.c:
+	* butterfly.c:
+	* jtagmkII.c
+	* stk500.c
+	* stk500v2.c
+	* config.h
+	* config.c
+	* config_gram.h	
+	* config_gram.y
+	* lexer.l
+	* main.c
+	* avrdude.conf.in
+	
+	* add -f <[w|v]+> option 4 write and verify operations wich is
+	force skiping empty pages or bytes 4 writing, if part was previously
+	erased, and 4 verifying. code for avr910 and butterfly was hardly revised
+	to provide this options
+	
+	* also ones option supported by new definitions in configuration file - 
+	 default_fastwrite and default_fastverify
+	
+	* add option word_size in configuration memory definitions wich is force
+	the size of word in bytes. now memory of the part adresses by words. 
+	By default word size of FLASH memory is 2 bytes, and 1 byte 4 others
+	
 2005-09-21  Joerg Wunsch <j@uriah.heep.sax.de>
 
 	* main.c: Add the forgotten -B option to the option string in
